#ifndef __PVSDEFINITIONS_H
#define __PVSDEFINITIONS_H

#include "common.h"
#include <math.h>

////////////
//-- typedefs
//$$ 19.1. 2008 test for speed
#define USE_BIT_PVS


#ifdef USE_HASH_PVS

	//#include "HashPvs2.h"
	#include "HashPvs.h"

	#define PVS_TYPE 0

	namespace GtpVisibilityPreprocessor {
		typedef HashPvs<Intersectable *, PvsData> DefaultPvs;
		typedef HashPvsIterator<Intersectable *, PvsData> ObjectPvsIterator;
	}
#else
	#ifdef USE_BIT_PVS

		#include "BitVectorPvs.h"

		#define PVS_TYPE 2

		namespace GtpVisibilityPreprocessor {
			typedef BitVectorPvs<Intersectable *, PvsData> DefaultPvs;
			typedef BitVectorPvsIterator<Intersectable *, PvsData> ObjectPvsIterator;
		}

	#else // USE_VERBOSE_PVS
		#include "Pvs.h"

		#define PVS_TYPE 1

		namespace GtpVisibilityPreprocessor {
			typedef VerbosePvs<Intersectable *, PvsData> DefaultPvs;
			typedef PvsIterator<Intersectable *, PvsData> ObjectPvsIterator;
		}
	#endif
#endif

namespace GtpVisibilityPreprocessor {

typedef PvsEntry<Intersectable *, PvsData> ObjectPvsEntry;

}


#endif

